#!/usr/local/bin/perl
# !+-------------------------------------------------------------------------
#    Name:  dbamon_dbcedit.pl
# !*-------------------------------------------------------------------------

chop($P = `basename $0`);
$| = 1;
require "cgi_handlers.pl";
use DBI;
$SIG{'INT'} = 'IntHandler';
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
chop($hostname = `hostname`); 
undef %rqpairs;

#---- Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}
$font = "arial" if ! $font;

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

$remsh_cmd = "ssh $hostname "; 

#---- See if DBAmon is configured to use Oracle (it should be)
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  #$dbms = "oracle";
  $sql = ""; 
}

#------------------------------------------------------------------------------
sub msgOld
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "<br><font size=2>$date ${P} | <b>$msgmsg</b></font>\n";
}

#-----------------------------------------------------------------------------
sub error 
#-----------------------------------------------------------------------------
{
  local($errorMsg) = $_[0];

  print "Content-type: text/html\n\n";
  print "<head><title> Fatal Error</title></head>";
  print "<body>";

  print "<h2> The following error occured - $date</h2>";
  print "<hr noshade>";
  print "</hr noshade>";
  print "<h4> $errorMsg</h4>";
  $sqlerror = $DBI::errstr;
  print "<br>SQL statement: $sql";
  print "<br>SQL error: $sqlerror";

  print "</body>";
  print "</html>";

  exit(1);
}

#-----------------------------------------------------------------------------
sub connectDBOld
#-----------------------------------------------------------------------------
{
  $dbh = ""; 
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
    &displayError('Failed_on_DB_connect_in_updateDb');
}

#-----------------------------------------------------------------------------
sub writeDBC
#-----------------------------------------------------------------------------
{
  $dbcdata_in = $rqpairs{'text'};
  $tmpfl      = "/tmp/${P}_tmp_${$}.txt"; 
  ##&msg("DEBUG - dbcdata=<pre>$dbcdata_in</pre>"); 

  $lineswritten = 0;
  foreach (split(/\n/,$dbcdata_in))
  {
    #---- There is a stupid ^M at the end of every line. chop it
    chop; 
    #---- I want to preserve blank lines!!!
    ##   next if /^$/;

    $dbcdata_out .= "$_\n";   
    $lineswritten++; 
  }

  $dbcdata_out .= "#---- Edited by $P on $date - Client: $ENV{'REMOTE_HOST'}\n"; 
  $lineswritten++; 

  &msg("There are $lineswritten lines to be written"); 
  &msg("Writing DBC data to $tmpfl"); 
  open(DBC,">$tmpfl") || &error("Cannot open output $dbcfile - $!"); 
  print DBC $dbcdata_out; 
  close(DBC); 

  ##$cmd = "$remsh_cmd $hostname -l dbamon 'cat $tmpfl > $dbcfile'"; 
  ##$cmd = "$remsh_cmd $hostname 'cat $tmpfl > $dbcfile'"; 
  $cmd = "cat $tmpfl > $dbcfile"; 
  &msg("Moving temp file to $dbcfile - cmd=$cmd"); 
  $saveoutput = `$cmd 2>&1`; 
  &msg("Command output: $saveoutput"); 
  unlink($tmpfl); 

  $verify    = `cat $dbcfile`; 
  $verify_wc = `wc -l $dbcfile`;

  ##&msg("For verification purposes, DBC file $dbcfile and line count after changes:<pre><font face=consolas size=2>$verify</font></pre>"); 

  &msg("For verification purposes, DBC file $dbcfile and line count after changes:"); 
  print "<p><table bgcolor=lightgrey width=80%><td><td> <font face=consolas size=3><b><pre>$verify</pre></b></table>"; 
  &msg("File: $dbcfile Line count: $verify_wc"); 
  ##system("env > /tmp/webenv"); 
}

#-----------------------------------------------------------------------------
sub readDBC
#-----------------------------------------------------------------------------
{
  ##&msg("Reading dbcfile=$dbcfile"); 
  open(DBC,"$dbcfile") || &error("Cannot open input $dbcfile - $!"); 
  $dbcdata = ""; 
  $linesread = 0;
  while (<DBC>) 
  {
    $dbcdata .= $_;  
    $linesread++;
  }
  close(DBC); 

  &msg("Read $linesread lines from $dbcfile"); 
  &msg("To Cut/Paste use Ctrl+c and Ctrl+v"); 
  &msg("Make changes and click SAVE CHANGES below"); 
  print "
    <form method=\"POST\" action=\"/cgi-bin/$P\?$dbcfile?Process\">
    <style>
    .tattr { background-color: black; color: linen }
    </style>
    <font size=2 face=consolas>
    <script language='JavaScript'> function back() { history.go($goback); } </script>
    <font size=2>To return to Instance Summary: <a href='javascript:back()'><b>Click Here</b></a> . </font>
      <br>DBC Syntax Help: 
        <a href='http://dbamon.com/config/dbc_common.shtml'  ><b>Common  </b></a> - 
        <a href='http://dbamon.com/config/dbc_informix.shtml'><b>Informix</b></a> -
        <a href='http://dbamon.com/config/dbc_oracle.shtml'  ><b>Oracle-UX</b></a> -
        <a href='http://dbamon.com/config/dbc_oraclent.shtml'><b>Oracle-Win</b></a> -
        <a href='http://dbamon.com/config/dbc_oraapps.shtml' ><b>Oracle-Apps</b></a> -
        <a href='http://dbamon.com/config/dbc_mssql.shtml'   ><b>MSSQL</b></a> -
        <a href='http://dbamon.com/config/dbc_sap.shtml'     ><b>SAP</b></a> 
    <p><input type=submit value=' Save Changes'><br>
    <textarea class=tattr NAME='text' COLS=120 ROWS=20 WRAP='off'>$dbcdata</textarea>
    <br><input type=submit value=' Save Changes'>
    </form>
  "; 

  #---- Save copy of this file
  chop($dbcfileshort = `basename $dbcfile`); 
  $dbcfilesave = "/opt/dbamon/adm/instances_save/" . $dbcfileshort; 
  system("mkdir /opt/dbamon/adm/instances_save >/dev/null 2>&1"); 
  ##$cmd = "$remsh_cmd $hostname -l dbamon 'mkdir /opt/dbamon/adm/instances_save 2>/dev/null;cat $dbcfile >> $dbcfilesave'"; 
  $cmd = "cat $dbcfile >> $dbcfilesave'"; 
  &msg("Saving backup copy of DBC file to $dbcfilesave - cmd=$cmd"); 
  $saveoutput = `$cmd 2>&1`; 
  &msg("Command output: $saveoutput"); 
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
  local($Signal) = @_;
  &msg("Signal=$Signal received - exiting"); 
  exit(0);
}

#------------------------------------------------------------------------------
sub CheckForEvilness
#------------------------------------------------------------------------------
{
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}

#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&get_request;

$dbcfile = (split(/\?/,$ARGV[0]))[0];
$verb    = (split(/\?/,$ARGV[0]))[1];

$dbcfile =~ s/\\$//;

$links_include = `cat /opt/dbamon/lib/trans_links.txt`;
print "Content-type: text/html\n\n
  <title>DBAmon DBC Editor</title>
  <body bgcolor=white link=darkblue vlink=darkblue><font face=$font>
  <table width=750><tr><td><img src='/dbamon/img/dbamonlogo.jpg' width=750>
  <tr bgcolor=wheat><td><font face=$font size=5>
      <center>DBC Editor</center>
  </table>
  <table width=750> $links_include </table>
  <hr>
";

&msg("Starting - verb=$verb dbcfile=$dbcfile"); 

#---- Connect to DB (may not need this)
&connectDB;

#---- Process
if ($verb eq "Process")
{
  $goback = "-2"; 
  &writeDBC;
}
else
{
  #system("echo '' | mailx -s 'monitor--$P dbcfile=$dbcfile ($ENV{'REMOTE_HOST'})' bill.border\@thecompany.com");
  $goback = "-1"; 
  &readDBC;
}

print "<p>
<script language='JavaScript'> function back() { history.go($goback); } </script>
<font size=2><b><a href='javascript:back()'>Click Here</a> to return to the Instance Summary</b></font>
<p>
";

&msg("Done"); 
exit;
