sub log_msg(m,h)   
#------------------------------------------------------------------------------
#
# Write header message to log file 
#
#------------------------------------------------------------------------------
{
  my ($m, $h) = @_;

  #---- Vars
  my $sev     = ""; 
  my $sqltext = ""; 

  if ($debug_html) 
  {
    print "in log_msg h=$h \n";
  }

  if ($log_path eq "")
  {
    &error_msg("ERROR - SYSTEM Section variable log_path is null - exiting");
    exit 1;
  }

  my $nowdate = &getdate();

  open(LOG_PATH,">>$log_path") ||  &error_msg("Can't open append $log_path - $!");
  print LOG_PATH "\n-------$title[$h]-$nowdate-------\n";
  print LOG_PATH "$m\n"; 

  if ($h eq "") 
  {
    $h = 0;
  }

  if ($html_events_flag[$h] == 0) 
  {
    if ($debug_html) 
    {
      print "in log_msg event title h=$h\n";
    }
    open(HTML_EVENTS,">$html_events[$h]") ||  &error_msg("Can't open output $html_path[$h] - $!");

    print HTML_EVENTS "<title>DBAmon One Instance Event Log</title>\n";
    print HTML_EVENTS "<body bgcolor=white><font face=$font>\n";
    print HTML_EVENTS "<h3>DBAmon Event Log for Instance: $title[$h]</h3>\n";
    print HTML_EVENTS "<i><font size=1>This page was programatically recreated by DBAmon - $date</font></i>\n";

    $html_events_flag[$h] = 1;
  } 

  open(HTML_EVENTS,">>$html_events[$h]") ||  &error_msg("Cannot open output $html_path[$h] - $!");

  $m = "$titleraw[$h] $m";

  print HTML_EVENTS "<hr>
<div style='font-family:$www_font;font-size:10pt>
  ";

  if    (index($m,"***") > -1) 
  {
    print HTML_EVENTS "<img src='img/yellowball-89.gif'> <b> Warning Event" ;
    $sev = "W";
  }
  elsif (index($m,"!!!") > -1) 
  {
    print HTML_EVENTS "<img src='img/redball-89.gif'>    <b> Critical Event";
    $sev = "C";
  }
  elsif (index($m,"---") > -1) 
  {
    print HTML_EVENTS "<img src='img/greenball-89.gif'>  <b> User Event"    ;
    $sev = "U";
  }
  elsif (index($m,"...") > -1) 
  {
    print HTML_EVENTS "<img src='img/blueball-89.gif'>   <b> Info Event"    ;
    $sev = "I";
  }
  else
  {
    print HTML_EVENTS "<img src='img/whiteball-89.gif'>  <b> DBAmon Event" ;
    $sev = "?";
  }

  print HTML_EVENTS "<pre>\n" ;
  print HTML_EVENTS "[<a HREF='${dbamon_home}/errors.shtml#$msgid'>$msgid</a>] $m \n";
  print HTML_EVENTS "</pre>
</div>
  ";

  #---- Run sql to insert a row into repository 

  if ($hostname[$h] ne "" && $use_repository eq "Y" && $msgid ne "DBA301")
  {
    $_ = $m;
    s/'/"/g;
    $m = $_;

    open(SQLFIL,  ">$sqlfil") || &error_msg("Can't open output $sqlfil - $!");
    print SQLFIL "$sqltext";
    close(SQLFIL);

    $sqltext  = "insert into dbamon.events (dbms,instance,system,sev,source,text,paged)\n";
    $sqltext .= "values ('$dbmsout[$h]','$title[$h]','$hostname[$h]','$sev','DBAmon $verrel','$msgid $m','$page_sent')";
    &runSQL($sqltext);
  }

  #---- Return 
  $msgid = "";
  return;
}

#------------------------------------------------------------------------------
1;
